import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Swan here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Swan extends Animal
{
    /**
     * Act - do whatever the Swan wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    private static int x, y;
    private int velocidad;
    private int tiempo;
    boolean choque;
    boolean invensibilidad;
    int frames;
    GreenfootSound smash = new GreenfootSound("sounds/smash.mp3");
    GreenfootSound coin = new GreenfootSound("sounds/coin.mp3");
    GreenfootSound vida = new GreenfootSound("sounds/vida.mp3");
    GreenfootSound poder = new GreenfootSound("sounds/poder.mp3");
    
    public Swan(){
     velocidad = 2;   
     tiempo = 0;
     choque = false;
    }
    
    public void act() 
    {
        mover();
        choque();
        poder();
        aumentarVelocidad();
    }
    
    public void mover(){
        y = getY();
        x = getX();
        if(Greenfoot.isKeyDown("up") && y > 510)
        {
           y-=velocidad; 
        }
        if(Greenfoot.isKeyDown("down") && y < 735){
            y+=velocidad;
        }
        if(Greenfoot.isKeyDown("right") ){
            x+=velocidad;
        }
        if(Greenfoot.isKeyDown("left") && x > 100 ){
            x-=velocidad;
        }
        
        setLocation(x,y);
        
    }
    
    public void poder(){
     MyWorld esp = (MyWorld)getWorld();
     if(Greenfoot.isKeyDown("f") && esp.poder.getCont() > 0 && invensibilidad == false){
            invensibilidad = true;
            esp.poder.decrementar(1);
            setImage("images/poder.png"); //Cambia de imagen a la azul
            poder.play();
        }   
        
     //Defino el tiempo en que tarda la animación
     if (invensibilidad == true){
            frames++;
            if (frames == 360){
             setImage("images/CISNE.png");
             invensibilidad = false;
             frames = 0;
            }
        }
    }
    
    public void choque(){
        if (canSee(Tronco.class) && invensibilidad != true)
        {
            MyWorld esp = (MyWorld)getWorld();
            esp.vidas.decrementar(1);
            smash.play();
            eat(Tronco.class);
            setImage("images/oof.png");
            choque = true;
            if (esp.vidas.getCont() == 0){
                GameOver f = new GameOver(esp);
                getWorld().addObject(f,((getWorld().getWidth()/2)),((getWorld().getHeight()/2)));
            }
        }
        
        if (choque == true)
        {
            frames++;
            if (frames == 30) {
                choque = false;
                frames = 0;
                setImage("images/CISNE.png");
            }
        }
        
        if (canSee(Coin.class))
        {
            MyWorld esp = (MyWorld)getWorld();
        eat(Coin.class);
            coin.play();
            esp.puntos.incrementar(100);
    }
        
        if (canSee(Heart.class))
        {
            MyWorld esp = (MyWorld)getWorld();
        eat(Heart.class);
            vida.play();
            esp.vidas.incrementar(1);
    }
    
    }
    
    public void aumentarVelocidad(){
        tiempo++;
        if (tiempo == 1000 && velocidad < 5){
            velocidad++;
            tiempo = 0;
        }
        
    }
    
}
